%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Hauptprogramm zur Interpolation fr den planaren Zweigelenkroboter von Bild 3.5
%
%  Es gelten die DH-Parameter:
%  d1=0, a1=l1, alpha1= 0
%  d2=0, a1=l2, alpha2= 0
%
%  Der TCP kann sich in der x0- y0-Ebene bewegen
%  W. Weber, August 2001
%
%  Unterprogramme:
%   1.  rtrafo_pl2
%   2.
%  Erstellt von W.Weber, August 2001
%  Letzte nderung: 4.08.07 von W. Weber 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

close all; % alle Fenster zu, es zieht
clear all; % alle Variablen werden gelscht

%global l1 l2;
global A_wahl;
global acc_vek;
global v_vek;
global te;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%  A:  Allgemeine Angaben zu den Armteillngen, Interpolationsschrittweite und den gewnschten Bahnen
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


start_text=['                                                                         '
      '-------------------------------------------------------------------------'
   			'Programm Interpolation_Pl2 fr PTP-Interpolation und Linearinterpolation '
            'fr den Zweigelenkplanarroboter in W. Weber: Industrieroboter, Bild 3.5  '
            ' W. Weber, August 2001, Februar 2002                                     '     
  		'-------------------------------------------------------------------------'
   '                                                                         '];
disp(start_text);
%%  Vorbesetzung: Lngen der Armteile

l1=4;
l2=3;

disp('Lngen der Armteile: ')
l1
l2

schalt=input('Falls Sie andere Lngen verwenden wollen, geben Sie ja ein, sonst Rckgabetaste: ','s') ;

ent_mod=strcmp('ja',schalt);
if ent_mod==1
   disp('      ');
   l1=input('Geben Sie die Lnge l1 in Meter ein:   ');
	l2=input('Geben Sie die Lnge l2 in Meter ein:   ');
end


%if strcmp(schalt, 'ja')==1 
%l1=input('Geben Sie die Lnge l1 in Meter ein:   ');
%l2=input('Geben Sie die Lnge l2 in Meter ein   ');
%end

disp('Lngen der Armteile:')

 l1 
 l2

% Vorbesetzungen
acc_vek=[]; v_vek=[];
te=0;
clear qd;
qd=[];


T_Ipo=0.01;  %  Vorbesetzung: Interpolationsschrittweite
'Interpolationsschrittweite ist in Sekunden: ',T_Ipo
schalt=input('Falls Sie diese Schrittweite verndern wollen, geben Sie ja ein, sonst Rckgabetaste ','s') ;

if strcmp(schalt, 'ja')==1 
T_Ipo=input('Geben Sie die Interpolationsschrittweite in Sekunden ein: ');
end

'Interpolationsschrittweite: ',T_Ipo


schalt_koord=input(' Start- und Endposition in Winkeln: ja eingeben, kart. Eingabe: Rckgabetaste ','s') ;

disp('       ');
if strcmp(schalt_koord, 'ja')==1 
   q1a_grad=input('Startwinkel 1. Gelenk (q1a) in Grad ? ')   ;
   q1b_grad=input('Endwinkel   1. Gelenk (q1b) in Grad ? ')   ;
   q2a_grad=input('Startwinkel 2. Gelenk (q2a) in Grad ? ')   ;
   q2b_grad=input('Endwinkel   2. Gelenk (q2b) in Grad ? ')   ;
    q1a=q1a_grad*pi/180; q1b=q1b_grad*pi/180; q2a=q2a_grad*pi/180; q2b=q2b_grad*pi/180;
   
   qa=[q1a;q2a] ; qb=[q1b;q2b];
   disp('Vorwrtstransformation');
	pxa= l2*(cos(q1a+q2a))+l1*cos(q1a);
   pya= l2*(sin(q1a+q2a))+l1*sin(q1a);
   
   pxb= l2*(cos(q1b+q2b))+l1*cos(q1b);
	pyb= l2*(sin(q1b+q2b))+l1*sin(q1b);
   
   pa=[pxa; pya]
	pb=[pxb; pyb]
   
   %  A_wahl wird aus der Startlage berechnet, es kann beim Fahren der kartesischen Bahn dann
   %  vorkommen, dass fr die Ziellage, wenn eine Linearbahn gefahren wird, andere Winkel gewhlt werden 
   % als vorgegeben sind, da bei Vorgabe durch den Anwender Start- und Ziellage nicht dasselbe A_wahl 
   % haben knnen.
   
   %Vorbesetzungen
   error_msg=[]; qa_w1=[]; qa_w2=[];
   
   % Aufrufe
   [qa_w1, error_msg]=rtrafo_pl2(pa,1,l1,l2)    % A_wahl=1
   [qa_w2, error_msg]=rtrafo_pl2(pa,-1,l1,l2)   % A_wahl=-1

	if norm(qa-qa_w1) < norm(qa-qa_w2) 
      A_wahl=1 
   else 
      A_wahl=-1 
   end; 
   

else
   
 % Startlage und Ziellage werden in kartesischen Koordinaten angegeben.  
disp('    ')
pxa=input('x-Komponente des p-Vektors Startposition: ')
pya=input('y-Komponente des p-Vektors Startposition: ')
disp('      ')
pxb=input('x-Komponente des p-Vektors Zielposition: ')
pyb=input('y-Komponente des p-Vektors Zielposition: ')

pa=[pxa; pya]; %Ortsvektor von K0 auf StartpunktS
pb=[pxb; pyb]; %Ortsvektor von K0 auf Zielpunkt

% Auswahl einer von zwei mglichen Lsungen bei der Rckwrtstransformation
disp('        ');
A_wahl=input('Wahl der Lsung: A_wahl=-1: kleinerer Winkel A, A_wahl=1: grerer Winkel A, Ihre Wahl: ')

% Vorbesetzungen
qa=[]; qb=[]; error_msg=[];

[qa, error_msg]=rtrafo_pl2(pa,A_wahl,l1,l2);  % RTrafo, um fr PTP Bahn Startwinkel zu erhalten  
[qb, error_msg]=rtrafo_pl2(pb,A_wahl,l1,l2);  % RTrafo, um fr PTP Bahn Zielwinkel zu erhalten  

end

%schalt_bahn_lin=input('Soll Linearbahn gefahren werden? ''ja'' in Hochkomma, nein: Leertaste ') ;

%if strcmp(schalt_bahn_lin, 'ja')==1 
   
   % Read the velocity and acceleration for linear path:
%vp=input('Geschwindigkeit vp, Linearbahn: ')
%bp=input('Beschleunigung vp, Linearbahn: ')
%ipoart_lin=input('Profil Linearbahn: Rampenprofil: 1, Sinoidprofil=2, Ihre Wahl: ') % Interpolationsart

%end
disp('    ');
%bahnart=input('PTP-Bahn: 0, Linearbahn: 1, Zirkularbahn: 2, Spline_PTP: 3, Spline_CP: 4, IHRE WAHL: ') ;
bahnart=input('PTP-Bahn: 0, Linearbahn: 1, IHRE WAHL: ') ;


%schalt_bahn_ptp=input('Soll PTP-Bahn gefahren werden? ''ja'' in Hochkomma, nein: Leertaste ') ;

if bahnart==0    %% =0 : PTP-Bahn

%if strcmp(schalt_bahn_ptp, 'ja')==1 
disp('    ');
syncFlag=input('asynchrone PTP-Bahn: 0, synchrone PTP-Bahn : 1, vollsynchrone PTP-Bahn: 2, Ihre Wahl: ');
ipoart_ptp=input('Geschwindigkeitsprofil fr PTP-Bahn: Rampenprofil: 1, Sinoidenprofil: 2, Ihre Wahl: '); 
disp('    ');
vm1=input('Geschwindigkeit vm Gelenk 1: ')
bm1=input('Beschleunigung bm Gelenk 1: ')
disp('    ');
vm2=input('Geschwindigkeit vm Gelenk 2: ')
bm2=input('Beschleunigung bm Gelenk 2: ')

vm=[vm1;vm2];
bm=[bm1;bm2];

end

if bahnart==1  % =1 : Linearbahn
   vp=input('Geschwindigkeit vp, Linearbahn: ')
	bp=input('Beschleunigung vp, Linearbahn: ')
	ipoart_lin=input('Profil Linearbahn: Rampenprofil: 1, Sinoidprofil=2, Ihre Wahl: ') % Interpolationsart
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%  B:  Aufruf der gewnschten Berechnungen
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

pt=[];b_bahn=[];v_bahn=[];v_corr=[];b_corr=[];sep=[];tbp=[]; tvp=[]; tep=[]; korr_msg=''; % Vorbesetzungen

korr_msg=[]; % Vorbesetzung
if bahnart==1 ;  % hier Linearbahn
   [pt,v_bahn,b_bahn,v_corr,b_corr,sep,tbp,tvp,tep,korr_msg] = Lin_bahn2D(pa,pb,vp,bp,T_Ipo,ipoart_lin);
   %Lin_bahn_pl2;  % Berechnung des zeitabhngigen Ortsvektors pt als auch q=qd
   z=size(pt,2);
   
   % Vorbesetzungen
   q=[]; error_msg=[];
   
   for i = 1:1:z
   		 p_vek = pt(:,i);
  			[q,error_msg] = rtrafo_pl2(p_vek,A_wahl,l1,l2); % Rcktransformation fr 2 Gelenkplanarroboter W. Weber
			qd=[qd q];  % Winkel fr 2-Gelenkplanar-robotor		
	end; % fr for Schleife Rckwrtstransformation

   
   
end

if bahnart==0;   % hier PTP-Bahn

    % Initialisierungen
 qd_ptp=[];status=[];qp_ptp=[];qpp_ptp =[];  
     % Aufruf
[qd_ptp,status,qp_ptp,qpp_ptp]=ptp_pl2(qa,qb,vm,bm,syncFlag,ipoart_ptp,T_Ipo);

'Vorwrtstransformation'
px_ptp= l2*(cos(qd_ptp(1,:)+qd_ptp(2,:)))+l1*cos(qd_ptp(1,:));
py_ptp= l2*(sin(qd_ptp(1,:)+qd_ptp(2,:)))+l1*sin(qd_ptp(1,:));

end;

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% C: Grafische Darstellung der Ergebnisse
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
 z_time=[]; % Vorbesetzung
 if bahnart==1    % es wurde Linearbahn gefahren
 %if strcmp(schalt_bahn_lin, 'ja')==1 ; % Es wurde Linearbahn gefahren
   
   % Es wird geplottet: px(t), py(t).

% 1. Berechnung des Zeitfeldes
	z=size(pt,2);
   for i=1:z
      z_time(i)=i*T_Ipo;
   end
   
   p_kart=figure;
  	set(p_kart,'name','Bahn des TCP bei Linearbahn');
   axis('ij')
   grid on;
   p_drawp=line(pt(2,:),pt(1,:));
   set(p_drawp,'color',[1 0 0])
	xlabel('y0');
	ylabel('x0');
   title('Linearbahn')
   
	px_time=figure;
	set(px_time,'name','px(t) bei linearbahn');
	plot(z_time,pt(1,:));
	grid
	xlabel('Zeit/Sekunden');
	ylabel('x0(t)');

	py_time=figure;
	set(py_time,'name','py(t) bei Linearbahn')
	plot(z_time,pt(2,:));
	grid
	xlabel('Zeit/Sekunden');
	ylabel('y0(t)');

	q1_time=figure;
	set(q1_time,'name','q1(t) bei Linearbahn');
	plot(z_time,qd(1,:));
	grid
	xlabel('Zeit/Sekunden');
	ylabel('q1(t)');

	q2_time=figure;
	set(q2_time,'name','q2(t) bei Linearbahn');
	plot(z_time,qd(2,:));
	grid
	xlabel('Zeit/Sekunden');
	ylabel('q2(t)');
end

if bahnart==0;   % es wurde PTP-Bahn gefahren
   
   clear z_time_ptp;
   j1=size(qd_ptp,2);
   
   %for i=1:j1
   for i=1:j1

	z_time_ptp(i)=(i-1)*T_Ipo;	% Berechnung des Zeitfeldes
	end

    %z_time_ptp=[0, z_time_ptp];

   q1_pl_ptp=figure;
	set(q1_pl_ptp,'name','q1(t) bei PTP-Bahn');
	plot(z_time_ptp,qd_ptp(1,:));
	grid
	xlabel('Zeit/Sekunden');
	ylabel('q1(t)');

	q2_pl_ptp=figure;
	set(q2_pl_ptp,'name','q2(t) bei PTP-Bahn');
	plot(z_time_ptp,qd_ptp(2,:));
	grid
	xlabel('Zeit/Sekunden');
   ylabel('q2(t)');
   
   p_kart_ptp=figure;
  	set(p_kart_ptp,'name','Bahn des TCP bei PTP-Bahn');
   axis('ij')
   grid
   p_draw_ptp=line(py_ptp,px_ptp)
   set(p_draw_ptp,'color',[1 0 0])
   
	xlabel('y0');
	ylabel('x0');
   
   
   px_pl_ptp=figure;
	set(px_pl_ptp,'name','px(t) bei PTP-Bahn');
	plot(z_time_ptp,px_ptp);
	grid
	xlabel('Zeit/Sekunden');
	ylabel('x0(t)');

	py_pl_ptp=figure;
	set(py_pl_ptp,'name','py(t) bei PTP-Bahn')
	plot(z_time_ptp,py_ptp);
	grid
	xlabel('Zeit/Sekunden');
	ylabel('y0(t)');
   
 end
   
%if strcmp(schalt_bahn_ptp, 'ja')==1  &  strcmp(schalt_bahn_lin, 'ja')==1 % es wurde Linearbahn und PTP-Bahn gefahren

%q_compare1=figure
%set(q_compare1,'name','q1 Vergleich Linear- PTP-Bahn');
%plot(z_time,qd(1,:),'r')
%hold on
%plot(z_time_ptp,qd_ptp(1,:),'g');
%grid
%xlabel('time/sec');
%ylabel('q1_lin: red, q1_ptp: green');

%q_compare2=figure
%set(q_compare2,'name','q2 Vergleich Linear- PTP-Bahn');
%plot(z_time,qd(2,:),'r',z_time_ptp,qd_ptp(2,:),'g');
%grid
%xlabel('time/sec');
%ylabel('q2_lin: red, q2_ptp: green');

%p_comp=figure;
%axis('ij')
%grid
%p_drawp=line(py_ptp,px_ptp);
%set(p_drawp,'color',[1 0 0])
%line([pa(2),pb(2)],[pa(1),pb(1)]);
%title('PTP-Bahn: rot, Linear Bahn: Blau')
%xlabel('y0');
%ylabel('x0');

%end




%ax_x0_y0=axes;
%set(ax_x0_y0,'units','normalized','visible','off');
%text_x_reg1=text;
%text_x_reg2=text;

% set(text_x_reg1,'position',[0.0 1.05],'fontname','Arial Rounded MT Bold',...
%'fontsize',28,'color',[0 1 0],'string','RoCSy');
%	'fontsize',28,'color',[0 1 0],'string','RoCSy');
% set(text_x_reg2,'position',[0.2 0.9],'fontname','Arial Rounded MT Bold',...
%	'fontsize',48,'color',[1 0 0],'string','Regelung whlen');

%set(achsen,'xlim',[-(l1+l2),(l1+l2)],'ylim',[-(l1+l2),(l1+l2)])

%axes('position',[0.05,0.05,0.8,0.8],'xlim',[-(l1+l2),(l1+l2)],'ylim',[-(l1+l2),(l1+l2)])


%line([0,p(2)],[0,p(1)])
