function [p,v_bahn,b_bahn,v_corr,b_corr,se,tb,tv,te,korr_msg] = Lin_bahn2D(pa,pb,v,b,T_Ipo,Ipoart)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Linearinterpolation in einer Ebene z.B. fr 2-Gelenkplanarroboter Bild 3.5
% Algemein kann aber die Interpolation zwischen zwischen zwei beliebigen Vektoren pa und pb 
% durchgefhrt werden.
% Unterprogramme: 
% 	Rampenprofil 	[s,v_vek,acc_vek]= rampe_pl2(se,tb,tv,te,v_corr,b_corr,T_Ipo) ;  
%	Sinoidenprofil [s,v_vek,acc_vek]= sinoid_pl2(se,tb,tv,te,v_corr,b_corr,T_Ipo); 
%
% W. Weber , August 2001
%     nderung: 8.9.01 von W. Weber
% Letztenderung. 4.8.07
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

se = [norm(pb(1:2,1)-pa(1:2,1))]; % Berechnung der Bahnlnge
   
      if Ipoart==1   % Rampenprofil
         if T_Ipo^2*b > se
            b_corr=se/T_Ipo^2;
            v_corr=b_corr*T_Ipo;
            korr_msg=['Geschwindigkeit und Beschleunigung musste korrigiert werden (T_Ipo^2*b > se) '];
            tb=T_Ipo
            te=2*tb
            tv=tb
         else
            
          % hier: Beschleunigung muss nicht korrigiert werden         
         tb=v/b;
         te=tb+se/v;
                	if te < 2*tb		% 
				 		   korr_msg=['Geschwindigkeit musste korrigiert werden (te<2*tb) ']
                     v_corr =  sqrt(se*b) ;	
  				 		   % Anpassung an die Interpolationsschrittweite 
                     tb=fix(v_corr/(b*T_Ipo))*T_Ipo;  % fix: zum kleineren ganzen Wert abrunden
                     test_tb=[tb;T_Ipo]; % um tb auf maximalen wert zu prfen
                     tb=max(test_tb);  % minimaler Wert ist T_IPO fr tb
                     tv=fix(se/(v_corr*T_Ipo))*T_Ipo; 
                     test_tv=[tv;tb;T_Ipo]; % um tv auf maximalen wert zu prfen
                     tv=max(test_tv);  % minimaler Wert ist tb fr tv
                     te=tb+tv;
                     v_corr=se/tv; b_corr=v_corr/tb;
                  else
                     % Anpassung an die Interpolationsschrittweite 
                     tb=round(v/(b*T_Ipo))*T_Ipo;
                     test_tba=[tb,T_Ipo];
                     tb=max(test_tba);
                     tv=round(se/(v*T_Ipo))*T_Ipo;
                     test_tva=[tv;tb]; %um tv auf maximalen wert zu prfen
                     tv=max(test_tva);  % minimaler Wert ist tb fr tv
                     te=tb+tv;
                     v_corr=se/tv; b_corr=v_corr/tb;
                     korr_msg='';
  			 			end	
          
          [s,v_vek,acc_vek]= rampe(se,tb,tv,te,v_corr,b_corr,T_Ipo) ;  % Aufruf Berechnung von s
      	end
      end
      
      if Ipoart==2    % hier Sinoidprofil 
         if T_Ipo^2*b/2 > se
            b_corr=2*se/T_Ipo^2
            v_corr=b_corr*T_Ipo/2
            korr_msg=['Geschwindigkeit und Beschleunigung musste korrigiert werden (T_Ipo^2*b/2 > se) '];
            tb=T_Ipo
            te=2*tb
            tv=tb
         else

         tb=2*v/b;
         te=tb+se/v;
  			        	if te < 2*tb		% 
				 		   korr_msg=['Geschwindigkeit musste korrigiert werden '];
                     v_corr =  sqrt(se*b/2) ;	
                     % Anpassung an die Interpolationsschrittweite 
                     tb=fix(2*v_corr/(b_corr*T_Ipo))*T_Ipo;
                     test_tb=[tb;T_Ipo]; % um tb auf maximalen wert zu prfen
                     tb=max(test_tb);  % minimaler Wert ist T_IPO fr tb
                     tv=fix(se/(v_corr*T_Ipo))*T_Ipo; 
                     test_tv=[tv;tb;T_Ipo]; % um tv auf maximalen wert zu prfen
                     tv=max(test_tv);  % minimaler Wert ist tb fr tv                     
                     te=tb+tv;
                     v_corr=se/tv; b_corr=v_corr/tb;
  				 		else
                     % Berechnung mit Anpassung an Interpolationsschrittweite   
                     tb=round(2*v/(b*T_Ipo))*T_Ipo;
                     test_tba=[tb;T_Ipo]; %um tb auf maximalen wert zu prfen
                     tb=max(test_tba); % minimaler Wert ist T_IPO fr tb
                     tv=round(se/(v*T_Ipo))*T_Ipo; 
                     test_tvb=[tb;tv];
                     tv=max(test_tvb); % minimaler Wert ist tb fr tv
                     te=tb+tv;
                     v_corr=se/tv; b_corr=2*v_corr/tb;
                     korr_msg='';
  			 			end;	
                     
                     tb=round(v/(b*T_Ipo))*T_Ipo;
                     tv=round(se/(v*T_Ipo))*T_Ipo;
                     test_tba=[tv;tb]; %um tv auf maximalen wert zu prfen
                     tv=max(test_tba);  % minimaler Wert ist tb fr tv
                     te=tb+tv;
                     v_corr=se/tv; b_corr=v_corr/tb;

                     
       	[s,v_vek,acc_vek]= sinoid(se,tb,tv,te,v_corr,b_corr,T_Ipo);   % Aufruf Sinoidprofil
          
			end ,% fr Sinoidenprofil
       end ;    

		z = size(s,2);					                    % z holt sich die Anzahl der Abtastpunkte 
								    % aus der Matrix
		for i=1:z

  			if abs(se) <= 0,             		                    % se(1)==0,-> keine Bahnnderung
  
    		  		p(:,i) = pa(1:2,1);		                            % Vektor p bleibt immer der selbe
               v_bahn(:,i)=[0;0];
               b_bahn(:,i)=[0;0];                                  % keine Bewegung 
                  
 	      	else
  
    				p(:,i) = pa(1:2,1) + (pb(1:2,1)-pa(1:2,1)).*(s(1,i)/se(1));    % Berechnung der Zwischenstellungen der Strecke
               v_bahn(:,i) = (pb(1:2,1)-pa(1:2,1)).*(v_vek(1,i)/se(1));    % Berechnung der Zwischenstellungen d
               b_bahn(:,i) = (pb(1:2,1)-pa(1:2,1)).*(acc_vek(1,i)/se(1)); 
               %z_time=[z_time z*T_Ipo]
  			end; % fr Bahnberechnung Bahnpunkt-Linearbewegung
     
		end; % fr for Schleife Berechnung p 
      



      
