%%%%% Kubische splines im kartesischen Raum 
%%%%% hier fr zwei Bahnsegmente wobei der mittlere Punkt (Sttzstelle)
%%%%% mit einer definierten Geschwindigkeit zu durchfahren ist
%%%%% 19.9.01, W. Weber
%%%%%  nderung: Februar 2002
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
close all; % Fenster zu, es zieht
clear all;
%
%Vorbesetzungen
pa=[0;0;0]; pb=[0;0;0];pc=[0;0;0];

str_ueb=['----------------------------------------------------------------------'
   ' Kartesische Spline Interpolation bei einer Sttzstelle               '
   '   W. Weber, Februar 2002                                             '
   '----------------------------------------------------------------------'
   '                                                                      '] ;
disp(str_ueb)

pa=input('Geben Sie den Startpunkt pa in Koordinaten von K0 als Spaltenvektor als [px;py;pz] ein: ' )
pb=input('Geben Sie den Zwischenpunkt pb in Koordinaten von K0 als Spaltenvektor als [px;py;pz]ein: ' )
pc=input('Geben Sie den Endpunkt pc in Koordinaten von K0 als als [px;py;pz]Spaltenvektor ein: ' )

% Skalare Geschwindigkeitswerte als absolute Gren 
v01=input('Absolute Geschwindigkeit im Startpunkt pa als Skalar: ')
vp1=input('Absolute Geschwindigkeit im Zwischenpunkt pb als Skalar: ')
te1=input('Fahrzeit des ersten Bahnsegmentes in Sekunden: ')

v02=vp1; % Mit gleicher Geschwindigkeit durchfahren
vp2=input('Absolute Geschwindigkeit im Punkt pc als Skalar: ')
te2=input('Fahrzeit des zweiten Bahnsegmentes in Sekunden: ')

disp('  ')
disp(' Bestimmung des Richtungsvektors der Geschwindigkeit im Zwischenpunkt: ');
disp(' 100: Richtung von qa nach qb, 0: Richtung von qb nach qc, sonst: Zwischenwert'); 

spline_prozent=input('Faktor Richtung ? (zwischen 100 und 0): ') 
spline_fak=spline_prozent/100;

% Geschwindigkeitsvektoren
v01_vek=v01*(pb-pa)/norm(pb-pa);  % Betrag und Richtung der Startgeschwindigkeit

% die Endgeschwindigkeit des ersten Bahnsegmentes ist in Betrag und Richtung die Startgeschwindigkeit
% des 2. Bahnsegmentes
% Richtungsvektor eve1: die Vektoren pc-pb und pb-pa werden addiert: pc-pa und normiert 

zw1=spline_fak*(pb-pa)+(1-spline_fak)*(pc-pb);
eve1=zw1/norm(zw1);  % Richtungsvektor der Geschwindigkeit im Punkt pb

ve1_vek=vp1*eve1; % 
v02_vek=ve1_vek; % bei kubischen Splines mssen auch Richtungen der Geschw. bereinstimmen.
%ve1_vek=vp1*(pc-pa)/norm(pc-pa);

%eve2=((pc-pb)+spline_fak*(pb-pa))/norm((pc-pb)+spline_fak*(pb-pa))
%v02_vek=vp1*eve2;
%v02_vek=ve1_vek;

ve2_vek=vp2*(pc-pb)/norm(pc-pb);   %hier Bahnende, daher Richtung von pb nach pc

%ve2_vek=(vp2*(pc-pb)/norm(pc-pb)+vp2*(pc-pb)/norm(pc-pb))/2   %hier Bahnende, daher Richtung von pb nach pc


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%  Bahnberechnung
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

te=[te1 te2];

T_IPO=0.002; % Berechnung alle zwei Millisekunden
t_vek_1=[0:T_IPO:te(1)];
t_vek_2=[0:T_IPO:te(2)];

%1. Segment

a2_1=3*(pb-pa)/te(1)^2-(ve1_vek+2*v01_vek)/te(1)
a3_1=-2*(pb-pa)/te(1)^3+(ve1_vek+v01_vek)/te(1)^2

s1_t=v01_vek*t_vek_1 + a2_1 * (t_vek_1.* t_vek_1) + a3_1 *  (t_vek_1 .* t_vek_1 .* t_vek_1);
p1_t(1,:)=s1_t(1,:)+pa(1);
p1_t(2,:)=s1_t(2,:)+pa(2);
p1_t(3,:)=s1_t(3,:)+pa(3);

% aktuelle Bahnlnge (Nherung da Bahn zwischen zwei Zeitinkrementen mit dem Abstand T_IPO als
% Geradenstck angenhert wird 
int_zahl_1=size(s1_t); % (3 , Zahl der Interpolationen im ersten Segment)
lauf1=int_zahl_1(2);
laenge1_t(1)=0;
for i=2:lauf1
   laenge1_t(i)=laenge1_t(i-1)+sqrt((s1_t(1,i)-s1_t(1,i-1))^2+(s1_t(2,i)-s1_t(2,i-1))^2+(s1_t(3,i)-s1_t(3,i-1))^2);
   % aktuelle Bahnlnge als Geradenstckchen summiert
end;


s1_p_t= 2 * a2_1 * t_vek_1 + 3 * a3_1 *  (t_vek_1 .* t_vek_1 );
% p1_p_t=s1_p_t+v01_vek
p1_p_t(1,:)=s1_p_t(1,:)+v01_vek(1);
p1_p_t(2,:)=s1_p_t(2,:)+v01_vek(2);
p1_p_t(3,:)=s1_p_t(3,:)+v01_vek(3);

zw1=6* a3_1 *  t_vek_1 ;
p1_pp_t(1,:)=zw1(1,:)+ 2 * a2_1(1); 
p1_pp_t(2,:)=zw1(2,:)+ 2 * a2_1(2); 
p1_pp_t(3,:)=zw1(3,:)+ 2 * a2_1(3); 


%2. Segment

a2_2=3*(pc-pb)/te(2)^2-(ve2_vek+2*v02_vek)/te(2)
a3_2=-2*(pc-pb)/te(2)^3+(ve2_vek+v02_vek)/te(2)^2

s2_t=v02_vek*t_vek_2 + a2_2 * (t_vek_2.* t_vek_2) + a3_2 *  (t_vek_2 .* t_vek_2 .* t_vek_2);
p2_t(1,:)=s2_t(1,:)+pb(1);
p2_t(2,:)=s2_t(2,:)+pb(2);
p2_t(3,:)=s2_t(3,:)+pb(3);

int_zahl_2=size(s2_t); % (3 , Zahl der Interpolationen im ersten Segment)
lauf2=int_zahl_2(2);
laenge2_t(1)=laenge1_t(lauf1);
for i=2:lauf2
   laenge2_t(i)=laenge2_t(i-1)+sqrt((s2_t(1,i)-s2_t(1,i-1))^2+(s2_t(2,i)-s2_t(2,i-1))^2+(s2_t(3,i)-s2_t(3,i-1))^2);
   % aktuelle Bahnlnge als Geradenstckchen summiert
end;

s2_p_t= 2 * a2_2 * t_vek_2 + 3 * a3_2 *  (t_vek_2 .* t_vek_2 );
p2_p_t(1,:)=s2_p_t(1,:)+v02_vek(1);
p2_p_t(2,:)=s2_p_t(2,:)+v02_vek(2);
p2_p_t(3,:)=s2_p_t(3,:)+v02_vek(3);

zw2=6* a3_2 *  t_vek_2 ;
p2_pp_t(1,:)=zw2(1,:)+ 2 * a2_2(1); 
p2_pp_t(2,:)=zw2(2,:)+ 2 * a2_2(2); 
p2_pp_t(3,:)=zw2(3,:)+ 2 * a2_2(3); 



% Gesamtbahn
p_t=[p1_t p2_t]; % Positionsvektor als Funktion der Zeit
p_p_t=[p1_p_t p2_p_t]; % Geschwindigkeitsvektor als Funktion der Zeit
p_pp_t=[p1_pp_t p2_pp_t]; % Beschleunigungsvektor als Funktion der zeit
laenge_t=[laenge1_t laenge2_t]; % Bahnlnge als Funktion der Zeit (gefahrene Strecke, absolut!)
% absolute Geschwindigkeit als Skalar

anz=size(t_vek_1)+size(t_vek_2);

for i=1:anz(2)
s_p(i)=sqrt(p_p_t(1,i)*p_p_t(1,i)+p_p_t(2,i)*p_p_t(2,i)+p_p_t(3,i)*p_p_t(3,i)); % Betrag der Bahngeschwindigkeit
end
%s_p=[p_p_t(1,:);p_p_t(2,:);p_p_t(3,:)]
% absolute Beschleunigung als Skalar
for i=1:anz(2)
s_pp(i)=sqrt(p_pp_t(1,i)*p_pp_t(1,i)+p_pp_t(2,i)*p_pp_t(2,i)+p_pp_t(3,i)*p_pp_t(3,i)); % Betrag der Bahnbeschleunigung
end


%sp1=v0(1) + 2*a2(1)*t_vek_1 + 3*a3(1)*t_vek_1 .* t_vek_1; 
%spp1=2*a2(1)+6*a3(1)*t_vek_1;

%s2=qb+v0(2)*t_vek_2 + a2(2) * t_vek_2 .* t_vek_2 + a3(2) *  t_vek_2 .* t_vek_2 .* t_vek_2;
%sp2=v0(2) + 2*a2(2)*t_vek_2 + 3*a3(2)*t_vek_2 .* t_vek_2; 
%spp2=2*a2(2)+6*a3(2)*t_vek_2;


% absolute Zeit
t_vek_abs=[0:T_IPO:te(1), te(1):T_IPO:(te(1)+te(2))];


% Vergleich mit Matlab spline, entspricht eigenen Berechnungen
%x_feld=[0, te]
%y_feld=[v0,0,2*se,ve]
%s_mat=spline(x_feld,y_feld,t_vek);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  Plotausgaben
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%
%  3D  und 2D Ausgaben 
DreiD_s=figure;
subplot(2,2,1)
plot3(p_t(1,:),p_t(2,:),p_t(3,:),'r')
hold on;
plot3([pa(1),pb(1),pc(1)],[pa(2),pb(2),pc(2)],[pa(3),pb(3),pc(3)],'k--')
grid on;
xlabel('px in m'), ylabel('py in m'), zlabel('pz in m')
title('gestr. Linearbahn');

subplot(2,2,2)
xy_pl=plot(p_t(1,:),p_t(2,:),'r');
hold on;
plot([pa(1),pb(1),pc(1)],[pa(2),pb(2),pc(2)],'k--')
grid on;
xlabel('px in m'), ylabel('py in m');

subplot(2,2,3)
xz_pl=plot(p_t(1,:),p_t(3,:),'r');
hold on;
plot([pa(1),pb(1),pc(1)],[pa(3),pb(3),pc(3)],'k--')
xlabel('px in m'), ylabel('pz in m');
grid on;
subplot(2,2,4)
yz_pl=plot(p_t(2,:),p_t(3,:),'r');
hold on;
plot([pa(2),pb(2),pc(2)],[pa(3),pb(3),pc(3)],'k--')
xlabel('py in m'), ylabel('pz in m');
grid on;

% absolute Bahngren
abs_groesse=figure;
subplot(2,2,1)
plot3(p_t(1,:),p_t(2,:),p_t(3,:))
grid on;
xlabel('px in m'), ylabel('py in m'), zlabel('pz in m');
subplot(2,2,2)
laeng_pl=plot(t_vek_abs,laenge_t);
grid on;
xlabel('t in Sek.'), ylabel('Bahnlnge in m');
subplot(2,2,3)
sp=plot(t_vek_abs,s_p);
xlabel('t in Sek.'), ylabel('|ds/dt| in m/s');
grid on;
subplot(2,2,4)
spp=plot(t_vek_abs,s_pp);
xlabel('t in Sek.'), ylabel('|ds/dt| in m/s');
grid on;


% Geschwindigkeit in Einzelnen Koordinaten und absolute Bahngeschwindigkeit
figure;
subplot(2,2,1);
v_pl_x=plot(t_vek_abs,p_p_t(1,:),'k');
xlabel('t in Sek.'), ylabel('px/dt in m/s');
grid on;

subplot(2,2,2)
v_pl_y=plot(t_vek_abs,p_p_t(2,:),'k');
xlabel('t in Sek.'), ylabel('py/dt in m/s');
grid on;

subplot(2,2,3)
v_pl_z=plot(t_vek_abs,p_p_t(3,:),'k');
xlabel('t in Sek.'), ylabel('pz/dt in m/s');
grid on;

subplot(2,2,4)
v_pl_abs=plot(t_vek_abs,s_p,'k');
xlabel('t in Sek.'), ylabel('|ds/dt| in m/s');
grid on;

% Beschleunigung in einzelnen Koordinaten und absolute Bahnbeschleunigung
figure;
subplot(2,2,1);
b_pl_x=plot(t_vek_abs,p_pp_t(1,:),'k');
xlabel('t in Sek.'), ylabel('px/dt in m/s');
grid on;

subplot(2,2,2)
b_pl_y=plot(t_vek_abs,p_pp_t(2,:),'k');
xlabel('t in Sek.'), ylabel('py/dt in m/s');
grid on;

subplot(2,2,3)
b_pl_z=plot(t_vek_abs,p_pp_t(3,:),'k');
xlabel('t in Sek.'), ylabel('pz/dt in m/s');
grid on;
subplot(2,2,4)
b_pl_abs=plot(t_vek_abs,s_pp,'k');
xlabel('t in Sek.'), ylabel('|ds/dt| in m/s');
grid on;



